#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/resource.h>

#include <libyang/libyang.h>

int main(int argc, char *argv[])
{
	struct ly_ctx *ctx;
	struct lyd_node *data;
	int i, rounds;

	setpriority(PRIO_PROCESS, 0, -20);

	/* libyang context */
	ctx = ly_ctx_new(NULL);
	if (!ctx) {
		fprintf(stderr, "Failed to create context.\n");
		return 1;
	}

	/* schema */
        if (!ly_ctx_load_module(ctx, "ietf-interfaces", NULL)) {
		fprintf(stderr, "Failed to load data model 0.\n");
		goto cleanup;
	}
        if (!ly_ctx_load_module(ctx, "iana-if-type", NULL)) {
		fprintf(stderr, "Failed to load data model 1.\n");
		goto cleanup;
	}
        if (!ly_ctx_load_module(ctx, "ericsson-contexts-ipos", NULL)) {
		fprintf(stderr, "Failed to load data model 2.\n");
		goto cleanup;
	}

        if (!ly_ctx_load_module(ctx, "ericsson-context-ipos", NULL)) {
		fprintf(stderr, "Failed to load data model 3.\n");
		goto cleanup;
	}

        if (!ly_ctx_load_module(ctx, "ericsson-interfaces-ext-ipos", NULL)) {
		fprintf(stderr, "Failed to load data model 4.\n");
		goto cleanup;
	}

        if (!ly_ctx_load_module(ctx, "ericsson-ethernet-ext-ipos", NULL)) {
		fprintf(stderr, "Failed to load data model 5.\n");
		goto cleanup;
	}


	/* data */
	rounds = atoi(argv[1]);
	for (i = 0; i < rounds; i++) {
		data = lyd_parse_path(ctx, "./datastore3.xml", LYD_XML, LYD_OPT_DESTRUCT);
		if (!data) {
			fprintf(stderr, "Failed to load data.\n");
			goto cleanup;
		}
	    	lyd_free_withsiblings(data);
	}
	
cleanup:
	ly_ctx_destroy(ctx, NULL);

	return 0;
}

